#!/usr/bin/env python

import spark
from helper import getValue

defined_classes = []
requested_parents = []


class HTBCheckTree(spark.GenericASTTraversal):
    def __init__(self, ast):
        spark.GenericASTTraversal.__init__(self, ast)
        self.postorder()

    def n_root(self, node):
        defined_classes.append(node.classid)
    
    def n_classdef(self, node):
        if not getValue(node, 'rate'):
            print "Error: `rate' for class MUST be set.\n"
            raise RuntimeError

        ## we can, also, set ceil = rate if ceil omitted
        ## (if you don't think that would be better done in `generate'):
        #import token
        #if not getValue(node, 'ceil'):
        #    ceil = token.Token('ceil', attr='ceil')
        #    ceil.value = getValue(node, 'rate')
        #    node.params.append(ceil)

        defined_classes.append(node.classid)
        requested_parents.append(node.parent)

    def n_classes(self, node):
        for p in requested_parents:
            if p.attr not in [ d.attr for d in defined_classes ]:
                print "Error: class %s does not exist.\n" % p.attr
                raise RuntimeError
